import { CfnBroker } from "aws-cdk-lib/aws-amazonmq";
import { IValidation } from "constructs";
export interface ActiveMqLdapAuthorizationProps {
    readonly config: CfnBroker.LdapServerMetadataProperty;
}
/**
 * Validates if provided string is in form required by [Active MQ](https://docs.aws.amazon.com/amazon-mq/latest/developer-guide/security-authentication-authorization.html).
 */
export declare class ActiveMqLdapValidation implements IValidation {
    readonly ActiveMqLdapAuthorization: CfnBroker.LdapServerMetadataProperty;
    private readonly ditRegex?;
    errors: string[];
    constructor(props: ActiveMqLdapAuthorizationProps);
    private validateDit;
    private validateHosts;
    validate(): string[];
}
