/**
 * When invoking custom resources dynamics references to SecretsManager's Secrets are not resolved although they appera to be passed.
 * As it is most likely that the users of this custom resource would like to use these to pass parameters not by actual value \
 * the capability to resolve SecretsManager's Secrets (and SSM Parameters although it does not work with CFN ATM) has been added.
 * This is achieved by replacing the dynamic references with the actual values (encoded
 */
export * from "./secret";
export * from "./string-parameter";
export * from "./dynamic-reference-extractor";
export declare function replaceDynamicReferences(text?: string): Promise<string | undefined>;
