import { RabbitApiCall } from "./types";
type RabbitMqRequestOptions = RabbitApiCall;
/**
 * Make a request to the RabbitMQ Management HTTP API.
 *
 * @param options the options for the request
 * @returns the response from the RabbitMQ Management HTTP API
 */
export declare const request: (options: RabbitMqRequestOptions) => Promise<{
    [key: string]: any;
} | undefined>;
export type RabbitApiResponse<TResponse> = {
    headers: {
        [key: string]: string;
    };
    statusCode: number | undefined;
    payload?: TResponse;
};
export {};
