import { Construct } from "constructs";
import { IRabbitMqBroker } from "./rabbitmq-broker";
import { RabbitMqBrokerDeploymentBase, RabbitMqBrokerDeploymentProps } from "./rabbitmq-broker-deployment";
export interface RabbitMqBrokerInstanceProps extends RabbitMqBrokerDeploymentProps {
}
/**
 * A representation of a single-instance broker comprised of one broker in one Availability Zone behind a Network Load Balancer (NLB)
 *
 * Additional optimizations:
 * - When subnet selection returns more then 1 subnets. A first one is picked. Warning is annotated
 */
export declare class RabbitMqBrokerInstance extends RabbitMqBrokerDeploymentBase implements IRabbitMqBroker {
    constructor(scope: Construct, id: string, props: RabbitMqBrokerInstanceProps);
}
